Index: /trunk/examples/designer/containerextension/containerextension.pro
===================================================================
--- /trunk/examples/designer/containerextension/containerextension.pro	(revision 992)
+++ /trunk/examples/designer/containerextension/containerextension.pro	(revision 993)
@@ -3,5 +3,4 @@
 #! [0]
 TARGET   = $$qtLibraryTarget($$TARGET)
-os2:TARGET_SHORT = $$qtLibraryTarget(cntrext)
 #! [1]
 CONFIG  += designer plugin
@@ -21,4 +20,6 @@
 #! [2]
 
+os2:TARGET_SHORT = $$qtLibraryTarget(cntrext)
+
 # install
 target.path = $$[QT_INSTALL_PLUGINS]/designer
Index: /trunk/examples/designer/customwidgetplugin/customwidgetplugin.pro
===================================================================
--- /trunk/examples/designer/customwidgetplugin/customwidgetplugin.pro	(revision 992)
+++ /trunk/examples/designer/customwidgetplugin/customwidgetplugin.pro	(revision 993)
@@ -3,5 +3,4 @@
 #! [0]
 TARGET      = $$qtLibraryTarget($$TARGET)
-os2:TARGET_SHORT = $$qtLibraryTarget(cstmwgt)
 #! [2]
 CONFIG      += designer plugin
@@ -16,4 +15,6 @@
 #! [3]
 
+os2:TARGET_SHORT = $$qtLibraryTarget(cstmwgt)
+
 # install
 target.path = $$[QT_INSTALL_PLUGINS]/designer
Index: /trunk/examples/designer/taskmenuextension/taskmenuextension.pro
===================================================================
--- /trunk/examples/designer/taskmenuextension/taskmenuextension.pro	(revision 992)
+++ /trunk/examples/designer/taskmenuextension/taskmenuextension.pro	(revision 993)
@@ -3,5 +3,4 @@
 #! [0]
 TARGET   = $$qtLibraryTarget($$TARGET)
-os2:TARGET_SHORT = $$qtLibraryTarget(tskmext)
 #! [1]
 CONFIG  += designer plugin
@@ -20,4 +19,6 @@
 #! [2]
 
+os2:TARGET_SHORT = $$qtLibraryTarget(tskmext)
+
 # install
 target.path = $$[QT_INSTALL_PLUGINS]/designer
Index: /trunk/examples/designer/worldtimeclockplugin/worldtimeclockplugin.pro
===================================================================
--- /trunk/examples/designer/worldtimeclockplugin/worldtimeclockplugin.pro	(revision 992)
+++ /trunk/examples/designer/worldtimeclockplugin/worldtimeclockplugin.pro	(revision 993)
@@ -3,5 +3,4 @@
 #! [0]
 TARGET      = $$qtLibraryTarget($$TARGET)
-os2:TARGET_SHORT = $$qtLibraryTarget(wrldclk)
 #! [1]
 CONFIG      += designer plugin
@@ -16,4 +15,6 @@
 #! [2]
 
+os2:TARGET_SHORT = $$qtLibraryTarget(wrldclk)
+
 # install
 target.path = $$[QT_INSTALL_PLUGINS]/designer
Index: /trunk/examples/tools/echoplugin/plugin/plugin.pro
===================================================================
--- /trunk/examples/tools/echoplugin/plugin/plugin.pro	(revision 992)
+++ /trunk/examples/tools/echoplugin/plugin/plugin.pro	(revision 993)
@@ -6,7 +6,8 @@
 SOURCES         = echoplugin.cpp
 TARGET          = $$qtLibraryTarget(echoplugin)
-os2:TARGET      = $$qtLibraryTarget(echopl)
 DESTDIR         = ../plugins
 #! [0]
+
+os2:TARGET_SHORT = $$qtLibraryTarget(echopl)
 
 # install
Index: /trunk/examples/tools/plugandpaintplugins/basictools/basictools.pro
===================================================================
--- /trunk/examples/tools/plugandpaintplugins/basictools/basictools.pro	(revision 992)
+++ /trunk/examples/tools/plugandpaintplugins/basictools/basictools.pro	(revision 993)
@@ -6,5 +6,4 @@
 SOURCES       = basictoolsplugin.cpp
 TARGET        = $$qtLibraryTarget(pnp_basictools)
-os2:TARGET    = $$qtLibraryTarget(pnp_bt)
 DESTDIR       = ../../plugandpaint/plugins
 #! [0]
Index: /trunk/examples/tools/plugandpaintplugins/extrafilters/extrafilters.pro
===================================================================
--- /trunk/examples/tools/plugandpaintplugins/extrafilters/extrafilters.pro	(revision 992)
+++ /trunk/examples/tools/plugandpaintplugins/extrafilters/extrafilters.pro	(revision 993)
@@ -6,8 +6,9 @@
 SOURCES       = extrafiltersplugin.cpp
 TARGET        = $$qtLibraryTarget(pnp_extrafilters)
-os2:TARGET    = $$qtLibraryTarget(pnp_ef)
 DESTDIR       = ../../plugandpaint/plugins
+#! [0]
 
-#! [0]
+os2:TARGET_SHORT = $$qtLibraryTarget(pnp_ef)
+
 # install
 target.path = $$[QT_INSTALL_EXAMPLES]/tools/plugandpaint/plugins