Index: trunk/client/src/help/ndpsmb_it.ipf
===================================================================
--- trunk/client/src/help/ndpsmb_it.ipf	(revision 995)
+++ trunk/client/src/help/ndpsmb_it.ipf	(revision 995)
@@ -0,0 +1,220 @@
+#include "nversion.h"
+. Italian version :encoding=Cp850:
+
+:userdoc.
+
+.nameit symbol=os text='<$OS>'
+.nameit symbol=nd text='<$ND> per &os.'
+.nameit symbol=ndcp text='Pannello di controllo di <$ND> per &os.'
+.nameit symbol=mp text='mount point'
+.nameit symbol=ressmb text='Impostazioni risorsa Samba'
+.nameit symbol=usage text='Uso'
+.nameit symbol=build text='Plugin client Samba per &os. versione <$NDPSMB_VERSION> build <$NDPSMB_BUILD>'
+
+:title.Aiuto Pannello di controllo di <$ND> per &os.
+
+:docprof toc=123456.
+.******************************************************
+:h1.Introduzione
+:p.
+Samba  una suite client/server per la condivisione di file e stampanti basata sul 
+protocollo SMB/CIFS, originariamente sviluppata nel mondo UNIX per avere accesso
+ai server e client &os. e Windows. &os. dispone di diverse implementazioni native
+del servizio SMB/CIFS - :hp1.Peer IBM:ehp1. (nella versione :hp1.LAN Requester IBM:ehp1.
+o in quella :hp1.Condivisione file e stampanti IBM:ehp1.) e :hp1.LAN Manager IBM:ehp1..
+Questi prodotti non sono aggiornati da molto tempo e hanno anche problemi di compatibilit
+
+con le implementazioni SMB/CIFS moderne di Windows.
+:p.
+Questo pacchetto  il port &os. del client Samba, implementato sotto forma di plugin per&colon.
+:ul.
+:li.&nd. - il ben noto file system virtuale per &os.
+:li.EVFS - il Virtual Filesystem per SMB di eComStation
+:eul.:p.
+Il plugin client Samba per &os. garantisce accesso senza problemi alle condivisioni file
+SMB/CIFS nella rete, utilizzando come sottostante protocollo di trasporto il TCP/IP puro
+(cio n NetBIOS n NetBIOS su TCP/IP).
+:p.
+Il plugin client Samba per &os. consiste di un modulo&colon.
+:ul.
+:li.ndpsmb.dll - il <$ND> plugin stesso
+:eul.:p.
+I rilasci precedenti la versione 1.5.0 comprendevano un secondo modulo, ora deprecato&colon.
+:ul.
+:li.smbcd.exe  - il demone client Samba, che processa le richieste ricevute da ndpsmb.dll
+:eul.
+.******************************************************
+:h1.Licenza
+:p.
+Samba  liberamente disponibile in accordo alla GNU General Public License v3. E' possibile ottenere 
+il codice sorgente completo sia dalla repository SVN del progetto (fare riferimento alla homepage
+Samba per &os. per dettagli su come scaricare il sorgente) o dalla homepage Samba 
+(vedi :link reftype=hd res=003.Collegamenti:elink.).
+:p.
+Il codice sorgente completo del plugin client Samba per &os.  anche disponibile dalla repository 
+SVN di Samba per &os..
+:p.
+Se stai usando questo plugin, ti preghiamo di voler supportare netlabs.org.
+Puoi fare riferimento alla homepage di Samba per &os. per ulteriori informazioni.
+:h2 res=003.Collegamenti
+:p.
+:ul.
+:li.Homepage Samba per &os. (http&colon.&slr.&slr.svn.netlabs.org&slr.samba)
+:li.Homepage <$ND> (http&colon.&slr.&slr.www.bmtmicro.com&slr.netdrive)
+:li.Homepage Samba (http&colon.&slr.&slr.www.samba.org)
+:eul.
+.*******************************************************
+:h1 res=1000 group=2 x=left y=top width=100% height=100% scroll=both.&ressmb.
+:i1 id=ressmb.&ressmb.
+:ul.
+:li.:link reftype=hd res=100.&ressmb.:elink.
+:li.:link reftype=hd res=101.&usage.:elink.
+:eul.
+:h2 res=100.&ressmb.
+:p.
+I parametri per una risorsa FS SMB/CIFS sono&colon.
+:parml.
+:pt.:hp2.Workgroup/Domain:ehp2.
+:pd.Il nome del gruppo di lavoro o dominio del server.
+:warning text='Default:'.
+:hp1.vuoto:ehp1.
+:ewarning.
+
+:pt.:hp2.Server:ehp2.
+:pd.Il nome o indirizzo IP del server che ospita la risorsa (condivisione).
+:warning text='Default:'.
+:hp1.vuoto:ehp1.
+:ewarning.
+
+:pt.:hp2.Share:ehp2.
+:pd.Il nome della risorsa desiderata sul server (condivisione).
+:warning text='Default:'.
+:hp1.vuoto:ehp1.
+:ewarning.
+
+:pt.:hp2.User ID:ehp2.
+:pd.Il nome utente da usare per l'autenticazione.
+:warning text='Default:'.
+:hp1.guest:ehp1.
+:ewarning.
+
+:pt.:hp2.Password:ehp2.
+:pd.La parola d'ordine per l'utente selezionato.
+:warning text='Default:'.
+:hp1.vuoto:ehp1.
+:ewarning.
+
+:pt.:hp2.Master:ehp2.
+:pd.Il nome del server o gruppo di lavoro browse master, utilizzato per ottenere la lista dei gruppi di lavoro disponibili se non si  specificato un gruppo di lavoro e server.
+:warning text='Default:'.
+:hp1.WORKGROUP:ehp1.
+:ewarning.
+
+:pt.:hp2.Master type:ehp2.
+:pd.Selezionare :hp2.server:ehp2. o :hp2.workgroup:ehp2. per identificare il tipo di master selezionato.
+:warning text='Default:'.
+:hp1.workgroup:ehp1.
+:ewarning.
+
+:pt.:hp2.Cache timeout:ehp2.
+:pd.La durata (in secondi) della validit
+ della cache. Una volta raggiunta la scadenza, il client
+rilegge la directory. Nel caso di cartelle con molti file, pu essere utile aumentare il timeout 
+(regola empirica: 10 secondi per 500-800 file).
+:warning text='Default:'.
+:hp1.10 secondi:ehp1.
+:ewarning.
+
+:pt.:hp2.Cache listings:ehp2.
+:pd.Il numero di directory da conservare in cache. Si tenga presente che maggiore  il valore, pi memoria verr
+ utilizzata.
+:warning text='Default:'.
+:hp1.32 directory:ehp1.
+:ewarning.
+
+:pt.:hp2.Supports EA:ehp2.
+:pd.Selezionare per utilizzare gli attributi estesi (Extended Attributes) <$OS> sul file system (e sul server) di destinazione.
+:warning text='Default:'.
+:hp1.selezionato:ehp1.
+:ewarning.
+
+:pt.:hp2.r/w:ehp2.
+:pd.Definisce se la risorsa deve essere in sola lettura (r) o scrivibile (w).
+
+:pt.hp2.Loglevel:ehp2.
+:pd.See chapter :hp2.Debugging:ehp2.
+:eparml.
+.******************************************************
+:h2 res=101.&usage.
+:p.
+Per montare una risorsa specifica,  necessario indicare sia il parametro :hp2.Server:ehp2.
+che quello :hp2.Share:ehp2.&semi. gli altri parametri sono opzionali. La radice della
+condivisione del server sar
+ montata sul &mp..
+:p.
+Per accedere a tutte le condivisioni presenti sul server, specificare solo il parametro 
+:hp2.Server:ehp2. (non quello :hp2.Share:ehp2.)&semi. gli altri parametri sono opzionali.
+L'elenco delle risorse condivise dal server sar
+ montato sul &mp..
+:p.
+Per accedere a tutti i server nel gruppo di lavoro o dominio, specificare solo il parametro
+:hp2.Workgroup/Domain:ehp2. (non quello :hp2.Server:ehp2.)&semi. gli altri parametri sono opzionali. 
+L'elenco dei server nel gruppo di lavoro o dominio specificato sar
+ montato sul &mp..
+:p.
+Per accedere a tutti i gruppi di lavoro elencati dal master browser nella rete, specificare
+solo il parametro :hp2.Master:ehp2. (non :hp2.Workgroup/Domain:ehp2. n :hp2.Server:ehp2.)&semi.
+gli altri parametri sono opzionali. L'elenco dei gruppi di lavoro sar
+ montato sul &mp.. 
+Il gruppo di lavoro master pu essere qualsiasi gruppo noto (raggiungibile) nella rete. Il 
+server master dovrebbe essere il master browser per il gruppo (o i gruppi) di lavoro.
+:p.
+Come valore di default, per accedere alla risorsa selezionata viene usato l'utente 
+:hp1.guest:ehp1. senza parola d'ordine. Se sul server non sono previsti utenti ospiti, 
+si ricever
+ probabilmente un errore &csq.access denied&csq.. Specificare la corretta
+combinazione nome utente / parola d'ordine.
+
+.******************************************************
+:h1.Versione
+:p.
+&build.
+:h1.Debugging
+:p.
+In order to produce a log file, choose an appropriate loglevel in the login dialogue.
+0 = do not log 2 = log a little 5 = log quite some stuff 10 = log everything.
+:p.
+Il file log viene creato nella directory specificata dalla variabile ambiente LOGFILES, se disponibile.
+Se la variabile ambiente LOGFILES non  stata definita, il file log viene creato nella directory &nd.. 
+Il nome del file  :hp1.log.ndpsmb.SHARE:ehp1. for the &nd. log and :hp1.log.smbd.SHARE:ehp1. for the Samba Client Plugin for &os. log.
+SHARE is the name of the connected share.
+
+.******************************************************
+:h1.Storia
+:p.Storia dei rilasci del client Samba per &nd.
+:ul.
+:li.:link reftype=hd res=011.Versione 1.0:elink.
+:li.:link reftype=hd res=012.Versione 1.5:elink.
+:li.:link reftype=hd res=013.Versione 2.0:elink.
+:li.:link reftype=hd res=014.Versione 2.1:elink.
+:li.:link reftype=hd res=015.Versione 2.2:elink.
+:li.:link reftype=hd res=016.Versione 2.3:elink.
+:eul.
+#include <changelog.txt>
+.******************************************************
+:h1.Ringraziamenti
+:ul.
+:li.Silvan Scherrer (aka diver)
+:li.Herwig Bauernfeind (aka HerwigB)
+:li.Dmitriy Kuminov (aka Dmik)
+:li.Vitali Pelenyov (aka sunlover)
+:li.Paul Smedley (aka Smedles)
+:li.Yuri Dario (aka Paperino)
+:li.Alex Taylor (aka AlexT)
+:li.Nikolay Kolosov (aka nickk)
+:li.Ko Myun Hun (aka komh)
+:li.e tutti quelli di cui ci siamo dimenticati 
+:eul.
+.******************************************************
+
+:euserdoc.
Index: trunk/client/src/help/readme_it.txt
===================================================================
--- trunk/client/src/help/readme_it.txt	(revision 995)
+++ trunk/client/src/help/readme_it.txt	(revision 995)
@@ -0,0 +1,202 @@
+#include <nversion.h>
+                      Plugin client Samba per <$OS>
+                      Versione <$NDPSMB_VERSION> Build <$NDPSMB_BUILD>
+                      ________________________________________________
+
+CONTENUTI
+_________
+
+ 1. Introduzione
+ 2. Licenza
+ 3. Installazione
+ 3.1 <$ND>
+ 3.2 EVFS
+ 3.3 Disinstallazione
+ 4. Uso di NDPSMB.DLL
+ 4.1 <$ND>
+ 4.2 EVFS
+ 5. Debugging
+ 6. Changelog
+
+
+1. Introduzione
+_______________
+
+Samba  una suite client/server per la condivisione di file e stampanti basata
+sul protocollo SMB/CIFS, originariamente sviluppata nel mondo UNIX per avere 
+accesso ai server e client <$OS> e Windows. <$OS> dispone di diverse 
+implementazioni native del servizio SMB/CIFS - Peer IBM (nella versione LAN 
+Requester IBM o in quella Condivisione file e stampanti IBM) e LAN Manager IBM.
+Questi prodotti non sono aggiornati da molto tempo e hanno anche problemi di 
+compatibilit
+ con le implementazioni SMB/CIFS moderne di Windows.
+
+Questo pacchetto  il port <$OS> del client Samba, implementato sotto 
+forma di plugin per
+
+- <$ND> per <$OS> - il ben noto file system virtuale per <$OS> o
+- EVFS - il Virtual Filesystem per SMB di eComStation
+
+Il plugin client Samba per <$OS> garantisce accesso senza problemi alle 
+condivisioni file SMB/CIFS nella rete, utilizzando TCP/IP come sottostante 
+protocollo di trasporto.
+
+Il plugin client Samba per <$OS> consiste di un modulo:
+   ndpsmb.dll - il <$ND>/EVFS plugin stesso.
+   
+I rilasci precedenti la versione 1.5.0 comprendevano un secondo modulo, ora 
+deprecato:
+   smbcd.exe  - il demone client Samba, che processa le richieste ricevute 
+                da ndpsmb.dll
+
+2. Licenza
+__________
+
+Samba  liberamente disponibile in accordo alla GNU General Public License v3.
+E' possibile ottenere il codice sorgente completo dalla nostra repository 
+SVN; fai riferimento alla homepage del progetto Samba per <$OS> per dettagli 
+su come scaricare il sorgente.
+
+Anche il codice sorgente completo del plugin <$ND>  disponibile.
+
+So if you are using our plugin we kindly ask you to support either
+bww bitwise works or netlabs.org.
+Please refer to the Samba for <$OS> Homepage to learn how you can do that!
+
+Collegamenti:
+
+Homepage Samba per <$OS>: http://samba.netlabs.org/
+Homepage <$ND>: http://www.blueprintsoftwareworks.com/netdrive/
+Homepage Samba: http://www.samba.org/
+
+
+3. Installazione
+________________
+
+Il plugin necessita del runtime klibc libc06*.dll (DLL runtime GCC InnoTek)
+nel LIBPATH, se non gi
+ presente (dovrebbe essere presente in tutte le
+versioni recenti di eComStation).
+Il plugin necessita dello stack TCP/IP 32 bit. Si tratta dello stack presente
+in tutte le versioni di eComStation. Se si dispone ancora di uno stack a
+16 bit, cercare in rete lo stack 32 bit.
+
+3.1 <$ND>
+____________
+
+E' necessario disporre di <$ND> ver. 2.2.1 o superiore prima di installare
+questo pacchetto. Se si vuole utilizzare l'API file 64bit, bisogna installare
+la ver. 2.3 o superiore di <$ND>. L'installazione  semiautomatica e consiste
+in:
+
+  - installazione ndpsmb.dll:
+      lanciare instpl.cmd da questo pacchetto. Tutti i file verranno copiati
+      nella cartella plugin di <$ND>.
+      
+3.2 EVFS
+________
+
+  - installazione ndpsmb.dll: 
+      copiare ndpsmb.dll in x:\ecs\dll (dove x:  la unit
+ di avvio)
+
+3.3 Disinstallazione
+____________________
+
+Lanciare lo script uninstpl.cmd per disinstallare il plugin. La procedura
+funziona sia per EVFS che per <$ND>.
+
+
+4. NDPSMB.DLL 
+_____________
+
+4.1. Uso con <$ND>
+_____________________
+
+Il plugin Samba <$ND> va usato in accordo con le regole generali di uso di
+<$ND>. Si veda la documentazione <$ND> per maggiori informazioni. Le risorse
+SMB/CIFS si possono montare sia usando l'utilit
+ linea di comando nd.exe che 
+con l'utilit
+ WPS ndpm.exe di <$ND>.
+
+I parametri del plugin Samba <$ND> sono:
+
+   workgroup     - il nome del gruppo di lavoro cui connettersi.
+   server        - il nome del server cui connettersi.
+   share         - il nome della risorsa del server (condivisione) cui connettersi.
+   user          - il nome dell'utente con cui connettersi.
+   password      - la parola d'ordine dell'utente selezionato.
+   master        - il nome del server o gruppo di lavoro 'master' utilizzato
+                   per ottenere la lista dei gruppi di lavoro disponibili se 
+                   non si  specificato un gruppo di lavoro e server.
+   masterttype   - 0 se 'master'  il nome del server master, 1 se 'master'
+                    il nome del gruppo di lavoro master.
+   cache timeout - la durata (in secondi) della validit
+ della cache; una volta
+                   raggiunta la scadenza, il client rilegge la directory; nel caso
+                   di cartelle con molti file, pu essere utile aumentare il timeout 
+                   (regola empirica: 10 secondi per 500-800 file).
+                   Default: 10 secondi
+   cache listings- il numero di directory da conservare in cache; si tenga presente
+                   che maggiore  il valore, pi memoria verr
+ utilizzata.
+                   Default: 32 directory
+   easupport     - 1 per supportare gli Attributi Estesi <$OS>, 0 per non supportarli
+   r/w           - definisce se la risorsa  in sola lettura (r) o scrivibile (w)
+   loglevel      - determines the ammount of information writte into a logfile
+
+Per montare una risorsa specifica,  necessario indicare sia il parametro 'server'
+che quello 'share'; gli altri parametri sono opzionali. La radice della condivisione
+del server sar
+ montata sul punto di aggancio.
+
+Per accedere a tutte le condivisioni presenti sul server, specificare solo il 
+parametro 'server' (non quello 'share'); gli altri parametri sono opzionali.
+L'elenco delle risorse condivise dal server sar
+ montato sul punto di aggancio.
+
+Per accedere a tutti i server nel gruppo di lavoro o dominio, specificare solo 
+il parametro 'workgroup' (non quello 'server'); gli altri parametri sono opzionali. 
+L'elenco dei server nel gruppo di lavoro specificato sar
+ montato sul punto di 
+aggancio.
+
+Per accedere a tutti i gruppi di lavoro elencati dal master browser nella rete,
+specificare solo il parametro 'master' (non 'workgroup' n 'server'); gli altri 
+parametri sono opzionali. L'elenco dei gruppi di lavoro sar
+ montato sul punto di
+aggancio. Il gruppo di lavoro 'master' pu essere qualsiasi gruppo noto nella 
+rete. Il server 'master' dovrebbe essere il master browser per il gruppo (o i 
+gruppi) di lavoro.
+
+Come valore di default, per accedere alla risorsa selezionata viene usato l'utente 
+'guest' senza parola d'ordine. Se sul server non sono previsti utenti ospiti, 
+si ricever
+ probabilmente un errore 'access denied'. Specificare la 
+corretta combinazione nome utente / parola d'ordine.
+
+4.2 Uso con EVFS
+________________
+
+eComStation dispone di EVFSGUI, un programma con interfaccia grafica che  pi
+ricco di opzioni rispetto all'interfaccia grafica di <$ND>. EFVSGUI pu
+anche essere usato in combinazione con <$ND>. In proposito, fare riferimento
+alla documentazione allegata ad eCS.
+
+5. Debugging
+____________
+
+In order to produce a log file, choose an appropriate loglevel in the login dialogue.
+0 = do not log 2 = log a little 5 = log quite some stuff 10 = log everything.
+
+Il file log viene creato nella directory specificata dalla variabile ambiente 
+LOGFILES, se disponibile. Se la variabile ambiente LOGFILES non  stata definita,
+il file log viene creato nella directory <$ND>. Il nome del file  log.ndpsmb.SHARE 
+for the <&ND> log and log.smbd.SHARE for the Samba Client Plugin for &os. log.
+SHARE is the name of the connected share.
+
+6. Storia
+_________
+
+#include <changelog.txt>